//------------------------------------------------------
// module  : kmean.h
// auteur  : Mignotte Max
// date    : 
//------------------------------------------------------
//

#ifndef KMEAN_H
#define KMEAN_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <new>
#include <time.h>

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define BIGNUMBER 100000000
#define TROIS 3
#define MAXGREYVALUE 255

//------------------------------------------------
// CLASSE KMEAN ----------------------------------
//------------------------------------------------
class kmean
 {
  public:
   int*     VectLabel;
   float**  MatrixPoints;
   float**  MatrixCenters;
   float**  MatrixParameterGaussian;

   //Flag
   int FlagKm_silent;
   int flag_ssilent;

   //Init
   float VarClusters;
   
  protected:
   int NbClusters;
   int NbPoints;
   int NbParam;

  public:
   kmean(int,float**,int,int);
   virtual ~kmean();

   void Clustering();

  protected:
   void  InitCenters();
   void  InitCenters2();
   int   Cluster();
   void  ComputeMean();
   void  VisuCenters();
   void  VisuClasses();

   void ComputeParameterGaussian();

   public:
   void PrintParameterGaussian();
};

#endif


